%global ui_commit 0.1.16
%global ui_modules_version 0.1.16
%global ui_src_name pcs-web-ui-%{ui_commit}
%global pyagentx_version   0.4.pcs.2
%global tornado_version    6.2.0
%global dacite_version  1.6.0
%global version_rubygem_backports  3.23.0
%global version_rubygem_childprocess  4.1.0
%global version_rubygem_daemons  1.4.1
%global version_rubygem_ethon  0.16.0
%global version_rubygem_eventmachine  1.2.7
%global version_rubygem_ffi  1.15.5
%global version_rubygem_mustermann  3.0.0
%global version_rubygem_nio4r 2.5.9
%global version_rubygem_puma 6.3.0
%global version_rubygem_rack  2.2.6.1
%global version_rubygem_rack_protection  3.0.5
%global version_rubygem_rack_test  2.0.2
%global version_rubygem_ruby2_keywords  0.0.5
%global version_rubygem_sinatra  3.0.5
%global version_rubygem_thin  1.8.1
%global version_rubygem_tilt  2.0.11
%global version_rubygem_webrick  1.7.0
%global pcs_bundled_dir pcs_bundled
%global pcsd_public_dir pcsd/public
%global rubygem_bundle_dir pcsd/vendor/bundle
%global rubygem_cache_dir %{rubygem_bundle_dir}/cache
%global rubygems_url https://rubygems.org/downloads
%global pcs_ui_url https://github.com/ClusterLabs/pcs-web-ui

%define debug_package %{nil}
%undefine __brp_mangle_shebangs

Summary: Pacemaker Configuration System
Name:    pcs
Version: 0.11.5
Release: 5%{?dist}.1
License: GPL-2.0-only AND Apache-2.0 AND MIT AND BSD-3-Clause AND (GPL-2.0-only OR Ruby) AND BSD-2-Clause AND (BSD-2-Clause OR Ruby)
URL:     https://github.com/ClusterLabs/pcs

Source0: %{url}/archive/refs/tags/v%{version}.tar.gz
Source1: https://github.com/ondrejmular/pyagentx/archive/v%{pyagentx_version}/pyagentx-%{pyagentx_version}.tar.gz
Source2: https://github.com/tornadoweb/tornado/archive/v%{tornado_version}/tornado-%{tornado_version}.tar.gz
Source3: https://github.com/konradhalas/dacite/archive/v%{dacite_version}/dacite-%{dacite_version}.tar.gz
Source4: %{rubygems_url}/backports-%{version_rubygem_backports}.gem
Source5: %{rubygems_url}/ethon-%{version_rubygem_ethon}.gem
Source6: %{rubygems_url}/ffi-%{version_rubygem_ffi}.gem
Source7: %{rubygems_url}/mustermann-%{version_rubygem_mustermann}.gem
Source8: %{rubygems_url}/childprocess-%{version_rubygem_childprocess}.gem
Source9: %{rubygems_url}/rack-%{version_rubygem_rack}.gem
Source10: %{rubygems_url}/rack-protection-%{version_rubygem_rack_protection}.gem
Source11: %{rubygems_url}/rack-test-%{version_rubygem_rack_test}.gem
Source12: %{rubygems_url}/sinatra-%{version_rubygem_sinatra}.gem
Source13: %{rubygems_url}/tilt-%{version_rubygem_tilt}.gem
Source14: %{rubygems_url}/eventmachine-%{version_rubygem_eventmachine}.gem
Source15: %{rubygems_url}/daemons-%{version_rubygem_daemons}.gem
Source16: %{rubygems_url}/thin-%{version_rubygem_thin}.gem
Source17: %{rubygems_url}/ruby2_keywords-%{version_rubygem_ruby2_keywords}.gem
Source18: %{rubygems_url}/webrick-%{version_rubygem_webrick}.gem
Source19: %{pcs_ui_url}/archive/%{ui_commit}/%{ui_src_name}.tar.gz
Source20: %{pcs_ui_url}/releases/download/%{ui_commit}/pcs-web-ui-node-modules-%{ui_modules_version}.tar.xz
Source21: %{rubygems_url}/nio4r-%{version_rubygem_nio4r}.gem
Source22: %{rubygems_url}/puma-%{version_rubygem_puma}.gem

# add support for OpenCloudOS
Patch5000: 0001-Support-for-OpenCloudOS.patch

BuildRequires: git-core coreutils gcc gcc-c++
BuildRequires: python3 python3-cryptography python3-dateutil python3-devel
BuildRequires: python3-setuptools python3-pycurl python3-pip python3-pyparsing
BuildRequires: python3-cryptography python3-lxml python3-wheel python3-setuptools_scm
BuildRequires: ruby ruby-devel rubygems rubygem-bundler rubygem-json rubygem-rexml rubygem-test-unit
BuildRequires: make booth corosync-qdevice-devel corosynclib-devel systemd pam
BuildRequires: npm fence-agents-common pacemaker-libs-devel resource-agents sbd nss-tools

Requires: python3 python3-cryptography python3-dateutil python3-lxml
Requires: python3-setuptools python3-pycurl python3-pyparsing python3-cryptography
Requires: ruby rubygems rubygem-json rubygem-rexml
Requires: psmisc pcmk-cluster-manager pacemaker-cli pam system-logos logrotate
Requires: (corosync if pacemaker)
Requires: (libknet1-plugins-all if corosync)
Suggests: pacemaker
%{?systemd_requires}

Provides: bundled(tornado) = %{tornado_version}
Provides: bundled(dacite) = %{dacite_version}
Provides: bundled(backports) = %{version_rubygem_backports}
Provides: bundled(daemons) = %{version_rubygem_daemons}
Provides: bundled(ethon) = %{version_rubygem_ethon}
Provides: bundled(eventmachine) = %{version_rubygem_eventmachine}
Provides: bundled(ffi) = %{version_rubygem_ffi}
Provides: bundled(mustermann) = %{version_rubygem_mustermann}
Provides: bundled(nio4r) = %{version_rubygem_nio4r}
Provides: bundled(puma) = %{version_rubygem_puma}
Provides: bundled(childprocess) = %{version_rubygem_childprocess}
Provides: bundled(rack) = %{version_rubygem_rack}
Provides: bundled(rack_protection) = %{version_rubygem_rack_protection}
Provides: bundled(rack_test) = %{version_rubygem_rack_test}
Provides: bundled(ruby2_keywords) = %{version_rubygem_ruby2_keywords}
Provides: bundled(sinatra) = %{version_rubygem_sinatra}
Provides: bundled(thin) = %{version_rubygem_thin}
Provides: bundled(tilt) = %{version_rubygem_tilt}
Provides: bundled(webrick) = %{version_rubygem_webrick}

%description
pcs is a corosync and pacemaker configuration tool.  It permits users to easily view, modify and
create pacemaker based clusters.

%package -n pcs-snmp
Summary: Pacemaker cluster SNMP agent
License: GPL-2.0-only and BSD-2-Clause
URL: https://github.com/ClusterLabs/pcs

BuildRequires: tar
Requires: pcs = %{version}-%{release}
Requires: pacemaker net-snmp
Provides: bundled(pyagentx) = %{pyagentx_version}

%description -n pcs-snmp
SNMP agent that provides information about pacemaker cluster to the master agent (snmpd)

%prep
%autosetup -D -T -b 19 -a 20 -S git -n %{ui_src_name} -N
%autopatch -p1 -m 3201 -M 4999

%autosetup -S git -n %{name}-%{version} -N
%autopatch -p1 -M 3200
%autopatch -p1 -m 5000

mkdir -p %{pcs_bundled_dir}/src
cp -f %SOURCE1 rpm/
cp -f %SOURCE2 rpm/
cp -f %SOURCE3 rpm/

mkdir -p %{rubygem_cache_dir}
cp -f %SOURCE4 %{rubygem_cache_dir}
cp -f %SOURCE5 %{rubygem_cache_dir}
cp -f %SOURCE6 %{rubygem_cache_dir}
cp -f %SOURCE7 %{rubygem_cache_dir}
cp -f %SOURCE8 %{rubygem_cache_dir}
cp -f %SOURCE9 %{rubygem_cache_dir}
cp -f %SOURCE10 %{rubygem_cache_dir}
cp -f %SOURCE11 %{rubygem_cache_dir}
cp -f %SOURCE12 %{rubygem_cache_dir}
cp -f %SOURCE13 %{rubygem_cache_dir}
cp -f %SOURCE14 %{rubygem_cache_dir}
cp -f %SOURCE15 %{rubygem_cache_dir}
cp -f %SOURCE16 %{rubygem_cache_dir}
cp -f %SOURCE17 %{rubygem_cache_dir}
cp -f %SOURCE18 %{rubygem_cache_dir}
cp -f %SOURCE21 %{rubygem_cache_dir}
cp -f %SOURCE22 %{rubygem_cache_dir}

%build
./autogen.sh
%{configure} \
    --enable-local-build \
    --enable-use-local-cache-only \
    --enable-individual-bundling \
    --enable-booth-enable-authfile-set \
    --enable-booth-enable-authfile-unset \
    PYTHON=%{__python3} ruby_CFLAGS="%{optflags}" ruby_LIBS="%{build_ldflags}" \
    %{nil}
make all

make -C %{_builddir}/%{ui_src_name} build BUILD_USE_EXISTING_NODE_MODULES=true

%install
rm -rf %{buildroot}
%make_install

cp -r %{_builddir}/%{ui_src_name}/build  %{buildroot}%{_libdir}/%{pcsd_public_dir}/ui

mkdir -p %{buildroot}%{_libdir}/%{pcsd_public_dir}/images/
ln -fs /etc/favicon.png %{buildroot}%{_libdir}/%{pcsd_public_dir}/images/favicon.png

mv %{rubygem_bundle_dir}/gems/backports-%{version_rubygem_backports}/LICENSE.txt backports_LICENSE.txt
mv %{rubygem_bundle_dir}/gems/daemons-%{version_rubygem_daemons}/LICENSE daemons_LICENSE
mv %{rubygem_bundle_dir}/gems/ethon-%{version_rubygem_ethon}/LICENSE ethon_LICENSE
mv %{rubygem_bundle_dir}/gems/eventmachine-%{version_rubygem_eventmachine}/LICENSE eventmachine_LICENSE
mv %{rubygem_bundle_dir}/gems/eventmachine-%{version_rubygem_eventmachine}/GNU eventmachine_GNU
mv %{rubygem_bundle_dir}/gems/ffi-%{version_rubygem_ffi}/COPYING ffi_COPYING
mv %{rubygem_bundle_dir}/gems/ffi-%{version_rubygem_ffi}/LICENSE ffi_LICENSE
mv %{rubygem_bundle_dir}/gems/ffi-%{version_rubygem_ffi}/LICENSE.SPECS ffi_LICENSE.SPECS
mv %{rubygem_bundle_dir}/gems/mustermann-%{version_rubygem_mustermann}/LICENSE mustermann_LICENSE
mv %{rubygem_bundle_dir}/gems/nio4r-%{version_rubygem_nio4r}/license.md nio4r_license.md
mv %{rubygem_bundle_dir}/gems/nio4r-%{version_rubygem_nio4r}/ext/libev/LICENSE nio4r_libev_LICENSE
mv %{rubygem_bundle_dir}/gems/puma-%{version_rubygem_puma}/LICENSE puma_LICENSE
mv %{rubygem_bundle_dir}/gems/childprocess-%{version_rubygem_childprocess}/LICENSE childprocess_LICENSE
mv %{rubygem_bundle_dir}/gems/rack-%{version_rubygem_rack}/MIT-LICENSE rack_MIT-LICENSE
mv %{rubygem_bundle_dir}/gems/rack-protection-%{version_rubygem_rack_protection}/License rack-protection_License
mv %{rubygem_bundle_dir}/gems/rack-test-%{version_rubygem_rack_test}/MIT-LICENSE.txt rack-test_MIT-LICENSE.txt
mv %{rubygem_bundle_dir}/gems/ruby2_keywords-%{version_rubygem_ruby2_keywords}/LICENSE ruby2_keywords_LICENSE
mv %{rubygem_bundle_dir}/gems/sinatra-%{version_rubygem_sinatra}/LICENSE sinatra_LICENSE
mv %{rubygem_bundle_dir}/gems/tilt-%{version_rubygem_tilt}/COPYING tilt_COPYING
mv %{rubygem_bundle_dir}/gems/webrick-%{version_rubygem_webrick}/LICENSE.txt webrick_LICENSE.txt

cp %{pcs_bundled_dir}/src/pyagentx-*/LICENSE.txt pyagentx_LICENSE.txt
cp %{pcs_bundled_dir}/src/pyagentx-*/CONTRIBUTORS.txt pyagentx_CONTRIBUTORS.txt
cp %{pcs_bundled_dir}/src/pyagentx-*/README.md pyagentx_README.md

cp %{pcs_bundled_dir}/src/tornado-*/LICENSE tornado_LICENSE
cp %{pcs_bundled_dir}/src/tornado-*/README.rst tornado_README.rst

cp %{pcs_bundled_dir}/src/dacite-*/LICENSE dacite_LICENSE
cp %{pcs_bundled_dir}/src/dacite-*/README.md dacite_README.md

/usr/lib/rpm/find-debuginfo.sh -j2 -m -i -S debugsourcefiles.list
rm -rf %{buildroot}%{_libdir}/debug
rm -rf %{buildroot}/usr/lib/debug
rm -rf %{buildroot}%{_prefix}/src/debug
rm -rf %{buildroot}%{_libdir}/%{rubygem_bundle_dir}/gems/eventmachine-%{version_rubygem_eventmachine}/ext
rm -rf %{buildroot}%{_libdir}/%{rubygem_bundle_dir}/gems/ffi-%{version_rubygem_ffi}/ext
rm -rf %{buildroot}%{_libdir}/%{rubygem_bundle_dir}/gems/nio4r-%{version_rubygem_nio4r}/ext
rm -rf %{buildroot}%{_libdir}/%{rubygem_bundle_dir}/gems/thin-%{version_rubygem_thin}/ext
rm -rf $RPM_BUILD_ROOT%{_libdir}/%{rubygem_bundle_dir}/gems/puma-%{version_rubygem_puma}/ext

%check
export PYTHONCOERCECLOCALE=0
%{__python3} pcs_test/suite --tier0 -v --vanilla --all-but \
pcs_test.tier0.daemon.app.test_app_remote.SyncConfigMutualExclusive.test_get_not_locked \
pcs_test.tier0.daemon.app.test_app_remote.SyncConfigMutualExclusive.test_post_not_locked \
|| exit 1

GEM_HOME=%{buildroot}%{_libdir}/%{rubygem_bundle_dir} ruby \
-I%{buildroot}%{_libdir}/pcsd \
-Ipcsd/test \
pcsd/test/test_all_suite.rb \
|| exit 1

%posttrans
%{_bindir}/systemctl daemon-reload
%{_bindir}/systemctl try-restart pcsd.service

%post
%systemd_post pcsd.service
%systemd_post pcsd-ruby.service

%post -n pcs-snmp
%systemd_post pcs_snmp_agent.service

%preun
%systemd_preun pcsd.service
%systemd_preun pcsd-ruby.service

%preun -n pcs-snmp
%systemd_preun pcs_snmp_agent.service

%postun
%systemd_postun_with_restart pcsd.service
%systemd_postun_with_restart pcsd-ruby.service

%postun -n pcs-snmp
%systemd_postun_with_restart pcs_snmp_agent.service

%files
%license tornado_LICENSE dacite_LICENSE COPYING backports_LICENSE.txt
%license childprocess_LICENSE daemons_LICENSE ethon_LICENSE eventmachine_LICENSE
%license eventmachine_GNU ffi_COPYING ffi_LICENSE ffi_LICENSE.SPECS nio4r_license.md nio4r_libev_LICENSE
%license mustermann_LICENSE rack_MIT-LICENSE rack-protection_License rack-test_MIT-LICENSE.txt
%license ruby2_keywords_LICENSE sinatra_LICENSE tilt_COPYING webrick_LICENSE.txt puma_LICENSE
%doc CHANGELOG.md README.md tornado_README.rst dacite_README.md
%config(noreplace) %{_sysconfdir}/pam.d/pcsd
%config(noreplace) %{_sysconfdir}/logrotate.d/pcsd
%config(noreplace) %{_sysconfdir}/sysconfig/pcsd
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/cfgsync_ctl
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/known-hosts
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.cookiesecret
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.crt
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.key
%ghost %config(noreplace) %attr(0644,root,root) %{_sharedstatedir}/pcsd/pcs_settings.conf
%ghost %config(noreplace) %attr(0644,root,root) %{_sharedstatedir}/pcsd/pcs_users.conf
%{_unitdir}/pcsd.service
%{_unitdir}/pcsd-ruby.service
%{python3_sitelib}/*
%{_sbindir}/pcs
%{_sbindir}/pcsd
%{_libdir}/pcs/*
%{_libdir}/pcsd/*
%{_datadir}/bash-completion/completions/pcs
%{_sharedstatedir}/pcsd
%dir %{_var}/log/pcsd
%{_mandir}/man8/pcs.*
%{_mandir}/man8/pcsd.*
%exclude %{_libdir}/pcs/pcs_snmp_agent
%exclude %{_libdir}/pcs/%{pcs_bundled_dir}/packages/pyagentx*

%files -n pcs-snmp
%license COPYING pyagentx_LICENSE.txt
%doc CHANGELOG.md pyagentx_CONTRIBUTORS.txt pyagentx_README.md
%config(noreplace) %{_sysconfdir}/sysconfig/pcs_snmp_agent
%{_unitdir}/pcs_snmp_agent.service
%{_libdir}/pcs/pcs_snmp_agent
%{_libdir}/pcs/%{pcs_bundled_dir}/packages/pyagentx*
%{_datadir}/snmp/mibs/PCMK-PCS*-MIB.txt
%{_mandir}/man8/pcs_snmp_agent.*

%changelog
* Wed Nov 15 2023 jiaxinyyang <jiaxinyyang@tencent.com> - 0.11.5-5.1
- debrand pcs 0.11.5 for TencentOS

* Thu Nov 09 2023 cunshunxia <cunshunxia@tencent.com> - 0.11.5-5
- upgrade rubygem_rack to 2.2.6.1
- fix CVE-2023-27530.

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11.5-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11.5-3
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 25 2023 Miaojun Dong <zoedong@tencent.com> - 0.11.5-2
- Rebuild for nodejs-18.14.2

* Thu Jul 13 2023 cunshunxia <cunshunxia@tencent.com> - 0.11.5-1
- upgrade to 0.11.5

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11.4-5
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 04 2023 Miaojun Dong <zoedong@tencent.com> - 0.11.4-4
- Fix rebuilt for OpenCloudOS Stream 23

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11.4-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 6 2023 Shuo Wang <abushwang@tencent.com> - 0.11.4-2
- backport patch from upstream to fix pcs start fail in ruby 3.2.0

* Tue Feb 28 2023 Shuo Wang <abushwang@tencent.com> - 0.11.4-1
- initial build
